#include "qurloperator.h"
#include "hackedurloperator.h"


HackedUrlOperator::HackedUrlOperator(QString url) : QUrlOperator(url)
{
  connect(this, SIGNAL(data(const QByteArray &, QNetworkOperation*)),
	  this, SLOT(slotData(const QByteArray &, QNetworkOperation*)));
  connect(this, SIGNAL(finished(QNetworkOperation*)),
	  this, SLOT(slotFinished(QNetworkOperation*)));
}

void HackedUrlOperator::slotData(const QByteArray &data, QNetworkOperation *op)
{
  static_cast<void>(op); /* Warning eater */
  str += QString(data);
}

void HackedUrlOperator::slotFinished(QNetworkOperation *op)
{
  if (op->state() != QNetworkProtocol::StDone) {
    fprintf(stderr,"Error receiving data from %s!\n",toString().latin1());
    return;
  }

  emit transferDone(&str);
}
