#ifndef HUBSTATUS_H
#define HUBSTATUS_H

#define MAXLOGLINES 250
#define HARDMAXLOGLINES 500

#include "qintdict.h"
#include "qlistview.h"

#include "hubstatusviewui.h"

class HubStatusItem : public QListViewItem
{
public:
  HubStatusItem(QTextEdit *logview, QListView *parent);
  virtual void activate();
  void update(QString adress, QString name, QString status, int users, int downloads, int uploads, double shares);
  void logText(QString newlogtext);
private:
  QStringList logtext;
  QTextEdit *logview;
};

class HubStatusView : public HubStatusViewUI
{
public:
  HubStatusView(QWidget *parent = 0);
  virtual void addHub(int hub);
  virtual void killHub(int hub);
  virtual void updateHub(int hub, QString adress, QString name, QString status, int users, int downloads, int uploads, double shares);
  virtual void logText(int hub, QString logtext);
private:
  QIntDict<HubStatusItem> hubs;
};

#endif // HUBSTATUS_H
