#include "distconfig.h"

#ifdef HAVE_ID3_TAG_H
#include <id3/tag.h>
#include <id3/misc_support.h>
#endif

#include "config.h"
#include "id3interface.h"

void Id3Interface::writeId3(QString file, QString artist, QString album, QString title, int trackno)
{
#ifdef HAVE_ID3_TAG_H
  ID3_Tag tag;
  tag.Link(file,ID3TT_NONE);
  tag.Strip();

  ID3_AddArtist(&tag, artist.latin1());
  ID3_AddAlbum(&tag, album.latin1());
  ID3_AddTitle(&tag, title.latin1());
  ID3_AddTrack(&tag, trackno);
  ID3_AddComment(&tag, DEFCOMMENT);
  
  tag.Update(global_config->useid3v2 ? ID3TT_ID3V2 : ID3TT_ID3V1);
#endif
}
