#include "qapplication.h"
#include "qvbox.h"
#include "qnetwork.h"
#include "qtabwidget.h"

#include "searchview.h"
#include "downloadview.h"
#include "configview.h"
#include "controller.h"
#include "config.h"
#include "quitter.h"

int main(int argc, char *argv[])
{
  qInitNetworkProtocols();
  QApplication app(argc, argv);
  configSetup();

  SearchView     *sview = new SearchView();
  DownloadView   *dview = new DownloadView();
  HubStatusView  *hview = new HubStatusView();
  controllerSetup(dview, hview);
  ConfigView     *cview = new ConfigView();

  QTabWidget *tabs = new QTabWidget();
  
  tabs->setMargin(5);
  tabs->addTab(sview, "Search");
  tabs->addTab(dview, "Download");
  tabs->addTab(cview, "Config");
  tabs->addTab(hview, "Status");
  tabs->setCaption("CdGet - the smart download system");
  app.setMainWidget(tabs);

  sview->show();
  dview->show();
  cview->show();
  tabs->show();

  Quitter quitter(&app);
  app.exec();
}
