#include "paintprogress.h"

#include <iostream>
#include <cmath>

#include <qlistview.h>
#include <qpainter.h>
#include <qfontmetrics.h>
#include <qnamespace.h>
#include <qcolor.h>

void PaintProgress::setText(const QString &text)
{
    this->text_ = text;
    parent->widthChanged();
}

QString PaintProgress::text()
{
    return this->text_;
}

void PaintProgress::setProgress(int progress)
{
    prog = (progress < 0) ? 0 : (progress > max) ? max : progress;
    parent->repaint();
}

void PaintProgress::setProgress2(int progress)
{
    prog2 = (progress < 0) ? 0 : (progress > max) ? max : progress;
    parent->repaint();
}

void PaintProgress::paint(QPainter *p, const QColorGroup &cg, 
                          int height, int width, int align)
{    
    // do not warn about unused align
    (void)align;
    
    int len = (int) floor(prog / (double) max * 
                          (width-3));

    int len2 = (int) floor(prog2 / (double) max * 
			   (width-3));

    w = width;

    p->fillRect(0, 1, width-3, height-2, cg.light());
    p->fillRect(0, 1, len2, height-2, QColor(19,244,113));
    p->fillRect(0, 1, len, height-2, QColor(120,200,250));


    p->setPen(cg.mid());
    p->drawRect(0, 1, width-3, height-2);

    p->setPen(cg.text());
    p->drawText(4, height-4, text_);
}

int PaintProgress::width(const QFontMetrics &fm) const
{
    return fm.size(Qt::SingleLine, text_).width();
}
