#include "qptrlist.h"
#include "qregexp.h"

#include "hackedurloperator.h"
#include "rootgetter.h"
#include "artistitem.h"
#include "albumitem.h"

RootGetter::RootGetter(QListView *tree, QString str) : HackedUrlOperator(str)
{
  this->tree = tree;
  connect(this, SIGNAL(transferDone(QString*)), this, SLOT(slotTransferDone(QString*)));
  get();
}

void RootGetter::slotTransferDone(QString *str)
{
  int pos = 0;
  bool virgin = true;

  QRegExp rx("<tr><td><a href=\"([^\"]*)\">([^/]*) / ([^<]*)</a>");
  QDict<ArtistItem> items;
  
  tree->setRootIsDecorated(true);
  while ( (pos = rx.search(*str, pos)) != -1 ) {

    ArtistItem *parent;
    QString url    = rx.cap(1);
    QString artist = rx.cap(2);
    QString album  = rx.cap(3);

    if (!(parent = items.find(artist.upper()))) {
      parent = new ArtistItem(tree, artist);
      items.insert(artist.upper(), parent);
    }

    parent->addChild(artist, new AlbumItem(parent, artist, album, url));
    pos += rx.matchedLength();
    virgin = false;
  }
  if (virgin) {
    new QListViewItem(tree, "No match found");
    tree->setRootIsDecorated(false);
  }
}
