#include "qurl.h"
#include "qcombobox.h"
#include "qlineedit.h"
#include "searchbox.h"

SearchBox::SearchBox(QWidget *parent, const char *name) : QComboBox(parent, name)
{
  setEditable(true);
  connect(lineEdit(), SIGNAL(returnPressed()), this, SLOT(slotReturnPressed()));
}  

QString SearchBox::queryString()
{
  QString tmp(currentText());
  QUrl::encode(tmp);
  return "words=" + tmp;
}

void SearchBox::slotReturnPressed(void)
{
  emit textEntered(currentText());
}

