#include "qbuttongroup.h"
#include "qradiobutton.h"
#include "qcheckbox.h"
#include "qlayout.h"

#include "searchgenrebox.h"

SearchGenreBox::SearchGenreBox(QWidget *parent) : QButtonGroup(4, Qt::Vertical, "Genre", parent)
{
  setInsideSpacing(0);
  setInsideMargin(5);

  all    = new QRadioButton("All", this);
  select = new QRadioButton("Select", this);

  addSpace(0);
  addSpace(0);

  blues      = new QCheckBox("Blues", this);
  classical  = new QCheckBox("Classical", this);
  country    = new QCheckBox("Country", this);
  data       = new QCheckBox("Data", this);
  folk       = new QCheckBox("Folk", this);
  jazz       = new QCheckBox("Jazz", this);
  misc       = new QCheckBox("Misc", this);
  newage     = new QCheckBox("Newage", this);
  reggae     = new QCheckBox("Reggae", this);
  rock       = new QCheckBox("Rock", this);
  soundtrack = new QCheckBox("Soundtrack", this);

  all->setChecked(true);

  blues->show();
  classical->show();
  country->show();
  data->show();
  folk->show();
  jazz->show();
  misc->show();
  newage->show();
  reggae->show();
  rock->show();
  soundtrack->show();
}

QString SearchGenreBox::queryString()
{
  if (all->isChecked()) return "allcats=YES";
 
  QString tmp("allcats=NO");
  if (blues->isChecked())      tmp += "&cats=blues";
  if (classical->isChecked())  tmp += "&cats=classical";
  if (country->isChecked())    tmp += "&cats=country";
  if (data->isChecked())       tmp += "&cats=data";
  if (folk->isChecked())       tmp += "&cats=folk";
  if (jazz->isChecked())       tmp += "&cats=jazzs";
  if (misc->isChecked())       tmp += "&cats=misc";
  if (newage->isChecked())     tmp += "&cats=newage";
  if (reggae->isChecked())     tmp += "&cats=reggae";
  if (rock->isChecked())       tmp += "&cats=rock";
  if (soundtrack->isChecked()) tmp += "&cats=soundtrack";

  return tmp;
}
