#include "qvbox.h"
#include "qhbox.h"
#include "qpopupmenu.h"

#include "searchview.h"
#include "downloadgenerator.h"

SearchView::SearchView(QWidget *parent) : QVBox(parent), rootgetter(0)
{
  results = new SearchResults(this);
  optionsbox = new QHBox(this);
    searchwhat  = new SearchWhatBox(optionsbox);
    searchgenre = new SearchGenreBox(optionsbox);
    optionsbox->setStretchFactor(searchwhat, 1);
    optionsbox->setStretchFactor(searchgenre, 2);
  searchbox   = new SearchBox(this);
  
  menu = new QPopupMenu(this);
  menu->insertItem("Download");

  connect(results, SIGNAL(contextMenuRequested(QListViewItem*, const QPoint &, int)),
	  this, SLOT(doPopupMenu(QListViewItem*, const QPoint &, int)));
  connect(searchbox, SIGNAL(textEntered(QString)), this, SLOT(startSearch()));
}

void SearchView::show()
{
  results->show();
  searchwhat->show();
  searchgenre->show();
  searchbox->show();
  QVBox::show();
}

void SearchView::startSearch()
{
  results->clear();
  if (rootgetter) delete rootgetter;

  QString query("http://www.freedb.org/freedb_search.php");
  query += "?" + searchbox->queryString();
  query += "&" + searchwhat->queryString();
  query += "&" + searchgenre->queryString();
  query += "&grouping=none";

  rootgetter = new RootGetter(results, query);
}

void SearchView::doPopupMenu(QListViewItem *item, const QPoint &pos, int col)
{
  static_cast<void>(col); /* Warning eater */
  if (menu->exec(pos) != -1)
    dynamic_cast<DownloadGenerator*>(item)->initDownloads(this);
}
