#include "qbuttongroup.h"
#include "qradiobutton.h"
#include "qcheckbox.h"
#include "qlayout.h"

#include "searchwhatbox.h"

SearchWhatBox::SearchWhatBox(QWidget *parent) : QButtonGroup(4, Qt::Vertical, "Search", parent)
{
  setInsideSpacing(0);
  setInsideMargin(5);

  all    = new QRadioButton("All", this);
  select = new QRadioButton("Select", this);

  addSpace(0);
  addSpace(0);

  artist = new QCheckBox("Artist", this);
  album  = new QCheckBox("Album", this);
  title  = new QCheckBox("Title", this);
  rest   = new QCheckBox("Rest", this);

  select->setChecked(true);
  artist->setChecked(true);
  album->setChecked(true);

  all->show();
  select->show();
  artist->show();
  album->show();
  title->show();
  rest->show();
}

QString SearchWhatBox::queryString()
{
  if (all->isChecked()) return "allfields=YES";
 
  QString tmp("allfields=NO");
  if (artist->isChecked()) tmp += "&fields=artist";
  if (album->isChecked())  tmp += "&fields=title";
  if (title->isChecked())  tmp += "&fields=track";
  if (rest->isChecked())   tmp += "&fields=rest";

  return tmp;
}
