#ifndef TRANSFER_H
#define TRANSFER_H

#include "qstring.h"

class TransferAgent;
class Transfer
{
public:
  Transfer(TransferAgent *agent = 0, QString id = 0);
  virtual ~Transfer();

  virtual Transfer *createTransfer(TransferAgent *agent, QString id) { 
    static_cast<void>(agent);
    static_cast<void>(id);
    return 0;
  }

  virtual bool startTransfer() { return false; }
  virtual bool stopTransfer()  { return false; }
  virtual bool resetTransfer() { return false; }
  virtual bool abortTransfer() { return false; }
  virtual bool modifyTransfer(QString & newkey) 
  { static_cast<void>(newkey); return false; }

  /* Transfers should override the functions below
   * when features are implemented */
  virtual bool allowesCreateTransfer() { return false; }
  virtual bool allowesStartTransfer()  { return false; }
  virtual bool allowesStopTransfer()   { return false; }
  virtual bool allowesResetTransfer()  { return false; }
  virtual bool allowesAbortTransfer()  { return false; }
  virtual bool allowesModifyTransfer() { return false; }

protected:
  /* Functions that are mapped to TransferAgent
   * must be implemented elsewhere because of mutual dependency */
  TransferAgent *transferChildCreated();
  void transferStatusChanged(QString status = 0, long pos = -1, long size = -1,
			     long speed = -1, long eta = -1,
			     double progress = -1, double target = -1);
  void transferCompleted();
  void transferRemoved();
  
private:
  TransferAgent *agent;
};

#endif // TRANSFER_H
